From: martinRenou <martin.renou@gmail.com>
Date: Thu, 28 Jul 2022 14:03:41 +0200
Subject: GHSL-2021-1024

Origin: https://github.com/jupyter/nbconvert/commit/48fe71eb3335caf4e03166e56e0d16efcfbeaf44
Bug: https://github.com/jupyter/nbconvert/security/advisories/GHSA-9jmq-rx5f-8jwq
Bug-Debian: https://security-tracker.debian.org/tracker/CVE-2021-32862
---
 .../exporters/tests/files/notebook_inject.ipynb    | 38 ++++++++++++++++++++++
 nbconvert/exporters/tests/test_html.py             |  4 +++
 nbconvert/templates/html/basic.tpl                 | 12 +++----
 3 files changed, 48 insertions(+), 6 deletions(-)

diff --git a/nbconvert/exporters/tests/files/notebook_inject.ipynb b/nbconvert/exporters/tests/files/notebook_inject.ipynb
index 8f3c8dd..bfd2163 100644
--- a/nbconvert/exporters/tests/files/notebook_inject.ipynb
+++ b/nbconvert/exporters/tests/files/notebook_inject.ipynb
@@ -136,6 +136,44 @@
       }
     ],
     "source": [""]
+   },
+   {
+    "cell_type": "code",
+    "execution_count": null,
+    "id": "d72e635a",
+    "metadata": {},
+    "outputs": [
+      {
+        "output_type": "execute_result",
+        "data": {
+         "image/png": ["abcd"]
+        },
+        "execution_count": null,
+        "metadata": {
+           "width": "><script>alert('output.metadata.width png injection')</script>"
+        }
+      }
+    ],
+    "source": [""]
+   },
+   {
+    "cell_type": "code",
+    "execution_count": null,
+    "id": "d72e635a",
+    "metadata": {},
+    "outputs": [
+      {
+        "output_type": "execute_result",
+        "data": {
+         "image/png": ["abcd"]
+        },
+        "execution_count": null,
+        "metadata": {
+           "height": "><script>alert('output.metadata.height png injection')</script>"
+        }
+      }
+    ],
+    "source": [""]
    }
  ],
  "metadata": {
diff --git a/nbconvert/exporters/tests/test_html.py b/nbconvert/exporters/tests/test_html.py
index 50b9866..f38fa68 100644
--- a/nbconvert/exporters/tests/test_html.py
+++ b/nbconvert/exporters/tests/test_html.py
@@ -168,3 +168,7 @@ class TestHTMLExporter(ExportersTestsBase):
             # Check injection in image data
             assert "<script>alert('image/png output')</script>" not in output
             assert "<script>alert('image/jpeg output')</script>" not in output
+
+            # Check injection in image width/height
+            assert "<script>alert('output.metadata.width png injection')</script>" not in output
+            assert "<script>alert('output.metadata.height png injection')</script>" not in output
diff --git a/nbconvert/templates/html/basic.tpl b/nbconvert/templates/html/basic.tpl
index f84a62b..5a62eb4 100644
--- a/nbconvert/templates/html/basic.tpl
+++ b/nbconvert/templates/html/basic.tpl
@@ -152,18 +152,18 @@ unknown type  {{ cell.type }}
 {%- endif %}
 {%- set width=output | get_metadata('width', 'image/png') -%}
 {%- if width is not none %}
-width={{ width }}
+width={{ width | escape_html }}
 {%- endif %}
 {%- set height=output | get_metadata('height', 'image/png') -%}
 {%- if height is not none %}
-height={{ height }}
+height={{ height | escape_html }}
 {%- endif %}
 {%- if output | get_metadata('unconfined', 'image/png') %}
 class="unconfined"
 {%- endif %}
 {%- set alttext=(output | get_metadata('alt', 'image/png')) or (cell | get_metadata('alt')) -%}
 {%- if alttext is not none %}
-alt="{{ alttext }}"
+alt="{{ alttext | escape_html }}"
 {%- endif %}
 >
 </div>
@@ -178,18 +178,18 @@ alt="{{ alttext }}"
 {%- endif %}
 {%- set width=output | get_metadata('width', 'image/jpeg') -%}
 {%- if width is not none %}
-width={{ width }}
+width={{ width | escape_html }}
 {%- endif %}
 {%- set height=output | get_metadata('height', 'image/jpeg') -%}
 {%- if height is not none %}
-height={{ height }}
+height={{ height | escape_html }}
 {%- endif %}
 {%- if output | get_metadata('unconfined', 'image/jpeg') %}
 class="unconfined"
 {%- endif %}
 {%- set alttext=(output | get_metadata('alt', 'image/jpeg')) or (cell | get_metadata('alt')) -%}
 {%- if alttext is not none %}
-alt="{{ alttext }}"
+alt="{{ alttext | escape_html }}"
 {%- endif %}
 >
 </div>
